﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;
using System.Collections;

namespace TemplateRowBug
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private string gridDataType = string.Empty;

        public MainWindow()
        {
            InitializeComponent();
            xamDataGrid1.FieldSettings.AllowEdit = true;
            
        }


        private void People_Click(object sender, RoutedEventArgs e)
        {
            gridDataType = "Person";

            BindingList<Person> people = new BindingList<Person>();
            people.Add(new Person() { FirstName = "John", LastName = "Smith Snr", DateOfBirth = new DateTime(1950, 5, 2), MaritalStatus = "Married" });
            people.Add(new Person() { FirstName = "John", LastName = "Smith Jnr", DateOfBirth = new DateTime(1970, 6, 3), MaritalStatus = "Divorced" });
            people.Add(new Person() { FirstName = "John", LastName = "Smith III", DateOfBirth = new DateTime(1990, 7, 4), MaritalStatus = "Single" });

            this.xamDataGrid1.DataContext = null;
            this.xamDataGrid1.DataSource = null;
            this.xamDataGrid1.FieldLayouts.Clear();

            this.xamDataGrid1.DataContext = Activator.CreateInstance(typeof(Person));
            this.xamDataGrid1.DataSource = (IEnumerable)people;
        }

        private void Cars_Click(object sender, RoutedEventArgs e)
        {
            gridDataType = "Car";
            BindingList<Car> cars = new BindingList<Car>();
            cars.Add(new Car() { Make = "Nissan", Model = "Patrol", Colour = "Red", ManufactureDate = new DateTime(2008, 1, 1)  });
            cars.Add(new Car() { Make = "Ford", Model = "Territory", Colour = "Black", ManufactureDate = new DateTime(2007, 6, 1) });
            cars.Add(new Car() { Make = "Hyundai", Model = "i30", Colour = "Orange", ManufactureDate = new DateTime(2010, 3, 3) });

            this.xamDataGrid1.DataContext = null;
            this.xamDataGrid1.DataSource = null;
            this.xamDataGrid1.FieldLayouts.Clear();

            this.xamDataGrid1.DataContext = Activator.CreateInstance(typeof(Car));
            this.xamDataGrid1.DataSource = (IEnumerable)cars;

        }

        private void xamDataGrid1_InitializeTemplateAddRecord(object sender, Infragistics.Windows.DataPresenter.Events.InitializeTemplateAddRecordEventArgs e)
        {
            if (gridDataType == "Person")
            {
                e.TemplateAddRecord.SetCellValue(e.TemplateAddRecord.FieldLayout.Fields["MaritalStatus"], "Single");
            }
            else if (gridDataType == "Car")
            {
                e.TemplateAddRecord.SetCellValue(e.TemplateAddRecord.FieldLayout.Fields["Colour"], "Blue");
            }
        }

        private void xamDataGrid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            e.FieldLayout.FieldSettings.ExpandableFieldRecordHeaderDisplayMode = ExpandableFieldRecordHeaderDisplayMode.AlwaysDisplayHeader;
            e.FieldLayout.Settings.AllowAddNew = true;
            e.FieldLayout.Settings.AllowDelete = true;
            e.FieldLayout.Settings.RecordSelectorLocation = RecordSelectorLocation.LeftOfCellArea;

            e.FieldLayout.Settings.AllowDelete = true;
            
        }
    }
}
